// Designed by Toshio Iwata at DIGITALFILTER.COM 2015/09/22

module fulladd4dvi (
  A, 
  B, 
  CIN,
  SUM, 
  COUT
); 

input A, B, CIN;
output SUM, COUT;

wire C1_C, C1_S, C2_C;

halfadd4dvi COMP1(
  .A(A),
  .B(B),
  .S(C1_S),
  .C(C1_C) );

halfadd4dvi COMP2(
  .A(C1_S),
  .B(CIN),
  .S(SUM),
  .C(C2_C) );

  assign COUT = C1_C | C2_C;

endmodule
